#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include "mtwist.h"
#include "randistrs.h"

#include "gamestate.h"
#include "gamestates.h"
#include "globals.h"
#include "constants.h"
#include "functions.h"

// Oplossing aan/uit zetten
// Pijltje bij ingang/uitgang
// Vinkje als ie af is

int init() {
    if (SDL_Init(SDL_INIT_TIMER | SDL_INIT_VIDEO) < 0) {
        return 1;
    }

    // freopen( "CON", "w", stdout );
    // freopen( "CON", "w", stderr );

    screen = SDL_SetVideoMode(SCR_W, SCR_H, SCR_BPP, SDL_SWSURFACE);
    if (screen == NULL) {
        return 2;
    }

    SDL_WM_SetCaption("Maze+ by Bob Rubbens", NULL);

    if (TTF_Init() < 0) {
        return 3;
    }

    fNormal = TTF_OpenFont("Media/db_quarz_mix.ttf", 60);
    if (fNormal == NULL) {
        return 4;
    }

    fSmall = TTF_OpenFont("Media/db_quarz_mix.ttf", 50);
    if (fSmall == NULL) {
        return 5;
    }

    fTag = TTF_OpenFont("Media/db_quarz_mix.ttf", 40);
    if (fTag == NULL) {
        return 9;
    }

    fBig = TTF_OpenFont("Media/db_quarz_mix.ttf", 230);
    if (fBig == NULL) {
        return 6;
    }

    fHeader = TTF_OpenFont("Media/db_quarz_mix.ttf", 100);
    if (fHeader == NULL) {
        return 7;
    }

    fMiniHeader = TTF_OpenFont("Media/db_quarz_mix.ttf", 80);
    if (fMiniHeader == NULL) {
        return 8;
    }

    gameMan = new cGameMan(STATE_INTRO);

    mt_seed(); // MERSENNE TWISTERRRRRRRRRRRRRRR

    return 0;
}

int maze() {
    while (gameMan->getState() != STATE_EXIT) {
        gameMan->currState->input();

        gameMan->currState->logic();

        gameMan->currState->render();

        SDL_Delay(1);

        gameMan->changeState();
    }

    return 0;
}

int quit() {
    TTF_CloseFont(fNormal);

    TTF_Quit();

    SDL_Quit();

    return 0;
}

int main(int argc, char *argv[])
{
    int retInit = init();
    if (retInit > 0) {
        return retInit;
    }

    maze();

    quit();

    return 0;
}
